import java.util.Vector;

public class MyContainer<T> implements Container<T> {
    // AF: { <dataCollection.get(i), versions.get(i)> | 0 <= i < dim }
    // IR: dataCollection != null && versions != null &&
    //     dim = dataCollection.size() = versione.size() &&
    //     (forall i. 0 <= i < dim. (dataCollection.get(i) != null) &&
    //                              (versions.get(i) >= 0)) &&
    //     (forall i,j. 0 <= i < j < dim.
    //                  dataCollection.get(i).getName() = dataCollection.get(j).getName() =>
    //                  versions.get(i) != versions.get(j))
    
    private int dim;
    private Vector<DataObject<T>> dataCollection;
    private Vector<Integer> versions;
    
    public MyContainer( ) {
        dataCollection = new Vector<DataObject<T>>();
        versions = new Vector<Integer>();
        dim = 0;
    }

    public int put(DataObject<T> dObj) throws NullPointerException {
        if (dObj == null) throw new NullPointerException();
        
        int ver = 0;
        for (int i = dim - 1; (i >= 0) && (ver == 0); i++)
            if (dObj.equals(dataCollection.get(i)))
                ver = versions.get(i) + 1;

        dataCollection.insertElementAt(dObj,dim);
        versions.insertElementAt(ver,dim);
        dim++;
        return ver;
    }
    /*
     REQUIRES: dObj != null
     THROWS: se dObj = null lancia NullPointerException
     MODIFIES: dim, dataCollection, versions
     EFFECTS: TO DO
     */

    /* restituisce il dataObject con nome numero versione, null altrimenti */
    public DataObject<T> get(String name, int version)
        throws NullPointerException, NegativeVersionException {
            if (name == null) throw new NullPointerException();
            if (version < 0) throw new NegativeVersionException();
            
            for (int i = 0; i < dim; i++)
                if ((name.equals(dataCollection.get(i).getName())) && (version == versions.get(i)))
                    return dataCollection.get(i);

            return null;
    }
    /*
     REQUIRES: name != null && version >= 0
     THROWS: se name = null lancia NullPointerException
             se version < 0 lancia NegativeVersionException (non presente in Java, checked)
     EFFECTS: TO DO
     */
}
